Bug 182251 - Overflow in /proc/diskstats on 64-bit systems
Overflow in /proc/diskstats on 64-bit systems
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: kernel (Show other bugs)
5
x86_64 Linux
medium Severity medium
: ---
: ---
Assigned To: Dave Jones
Brian Brock
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2006-02-21 08:40 EST by Kent Baxley
Modified: 2015-01-04 17:25 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2006-10-17 17:12:45 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Patch to address issue (1.56 KB, patch)
2006-02-21 08:42 EST, Kent Baxley
no flags Details | Diff

  None (edit)
Description Kent Baxley 2006-02-21 08:40:20 EST
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.7.12) Gecko/20060202 Fedora/1.0.7-1.2.fc4 Firefox/1.0.7

Description of problem:
On 64-bit machines, some values exported by /proc/diskstats, and then used by
iostat, can overflow.

For example:
Device:    rrqm/s wrqm/s   r/s   w/s  rsec/s  wsec/s    rkB/s    wkB/s avgrq-sz
avgqu-sz   await  svctm  %util
sda          5.50   0.00 143.96  0.00 307496983987862656.00    0.00
153748491993931328.00     0.00 2136028725038430.00     7.94   55.12   5.59  80.42

The patch attached seems to fix those problems, but might cause problems with
the soft kABI. Patch is from Ben Woodard <woodward@redhat.com>

This was also observed in RHEL 4, but the patch appears to be a kABI breaker.  I was asked to go ahead and open a Fedora Bug against this since there is currently no fix in the upstream kernel that addresses this.  This needs to be addressed in time for RHEL 5.

This problem was observed on x86_64 but may also affect ia64

Version-Release number of selected component (if applicable):


How reproducible:
Always

Steps to Reproduce:
1. Run iostat on a 64-bit system.

  

Actual Results:  What appears to be happening is when one counter wraps and not the other the value ends up being a large negative number.

Expected Results:  The output numbers should be more sane.

Additional info:

This was also observed in RHEL 4, but the patch sent over from Lawrence Livermore appears to be a kABI breaker.  I was asked to go ahead and open a Fedora Bug against this since there is currently no fix in the upstream kernel that addresses this.  This needs to be addressed in time for RHEL 5.

This problem was observed on x86_64 but may also affect ia64
Comment 1 Kent Baxley 2006-02-21 08:42:18 EST
Created attachment 124949 [details]
Patch to address issue

Patch attached.
Comment 3 Dave Jones 2006-03-04 17:29:57 EST
Please get this included upstream, and Fedora will inherit it on a rebase.
Comment 6 Dave Jones 2006-10-16 14:48:13 EDT
A new kernel update has been released (Version: 2.6.18-1.2200.fc5)
based upon a new upstream kernel release.

Please retest against this new kernel, as a large number of patches
go into each upstream release, possibly including changes that
may address this problem.

This bug has been placed in NEEDINFO state.
Due to the large volume of inactive bugs in bugzilla, if this bug is
still in this state in two weeks time, it will be closed.

Should this bug still be relevant after this period, the reporter
can reopen the bug at any time. Any other users on the Cc: list
of this bug can request that the bug be reopened by adding a
comment to the bug.

In the last few updates, some users upgrading from FC4->FC5
have reported that installing a kernel update has left their
systems unbootable. If you have been affected by this problem
please check you only have one version of device-mapper & lvm2
installed.  See bug 207474 for further details.

If this bug is a problem preventing you from installing the
release this version is filed against, please see bug 169613.

If this bug has been fixed, but you are now experiencing a different
problem, please file a separate bug for the new problem.

Thank you.

Note You need to log in before you can comment on or make changes to this bug.